// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutRecords`](crate::operation::put_records::builders::PutRecordsFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`records(PutRecordsRequestEntry)`](crate::operation::put_records::builders::PutRecordsFluentBuilder::records) / [`set_records(Option<Vec::<PutRecordsRequestEntry>>)`](crate::operation::put_records::builders::PutRecordsFluentBuilder::set_records):<br>required: **true**<br><p>The records associated with the request.</p><br>
    ///   - [`stream_name(impl Into<String>)`](crate::operation::put_records::builders::PutRecordsFluentBuilder::stream_name) / [`set_stream_name(Option<String>)`](crate::operation::put_records::builders::PutRecordsFluentBuilder::set_stream_name):<br>required: **false**<br><p>The stream name associated with the request.</p><br>
    ///   - [`stream_arn(impl Into<String>)`](crate::operation::put_records::builders::PutRecordsFluentBuilder::stream_arn) / [`set_stream_arn(Option<String>)`](crate::operation::put_records::builders::PutRecordsFluentBuilder::set_stream_arn):<br>required: **false**<br><p>The ARN of the stream.</p><br>
    /// - On success, responds with [`PutRecordsOutput`](crate::operation::put_records::PutRecordsOutput) with field(s):
    ///   - [`failed_record_count(Option<i32>)`](crate::operation::put_records::PutRecordsOutput::failed_record_count): <p>The number of unsuccessfully processed records in a <code>PutRecords</code> request.</p>
    ///   - [`records(Vec::<PutRecordsResultEntry>)`](crate::operation::put_records::PutRecordsOutput::records): <p>An array of successfully and unsuccessfully processed record results. A record that is successfully added to a stream includes <code>SequenceNumber</code> and <code>ShardId</code> in the result. A record that fails to be added to a stream includes <code>ErrorCode</code> and <code>ErrorMessage</code> in the result.</p>
    ///   - [`encryption_type(Option<EncryptionType>)`](crate::operation::put_records::PutRecordsOutput::encryption_type): <p>The encryption type used on the records. This parameter can be one of the following values:</p> <ul>  <li>   <p><code>NONE</code>: Do not encrypt the records.</p></li>  <li>   <p><code>KMS</code>: Use server-side encryption on the records using a customer-managed Amazon Web Services KMS key.</p></li> </ul>
    /// - On failure, responds with [`SdkError<PutRecordsError>`](crate::operation::put_records::PutRecordsError)
    pub fn put_records(&self) -> crate::operation::put_records::builders::PutRecordsFluentBuilder {
        crate::operation::put_records::builders::PutRecordsFluentBuilder::new(self.handle.clone())
    }
}
